// Metronome developed by Adam Hoyle
// provides a central sync.
//
// MetrodomeEvent *must* be declared first!
//
public class Conductor
{
    // declare variables
    //static MetronomeEvent @ evnt;
	static Event @ bar_event;
	static Event @ beat_event;
	// total number of bars since 'run' called.
	0 => static int total_bar_count;
	// current bar counter (in this loop)
    0 => static int bar_count;
	// current beat counter (in this loop)
	0 => static int beat_count;
	// how long a beat is (for beat length event)
	1::second => static dur beat_length;
	// how long a bar is (for bar length event)
	1::second => static dur bar_length;
	// how many beats there are per bar (usually 4)
	0 => static int beats_per_bar;
	// how many bars there are before
	// the beat and bar counters reset
	0 => static int bars_per_loop;
	// how many beats there are in a loop
	0 => static int beats_per_loop;
	// how many beats per minute
	0 => static int bpm;
	// initialise variables
    <<< "Conductor - creating conductor!!",
    "                                                    ." >>>;
    fun static void setTempo( int tmpo )
	{
		<<< "Conductor - setTempo", tmpo,
    "                                                    ." >>>;

		(bars_per_loop*beats_per_bar) => beats_per_loop;
		tmpo => bpm;
        (60.0/bpm)::second => beat_length;
		beat_length * beats_per_bar => bar_length;
		//evnt.setTempo( tmpo );
	}
	fun static void init()
	{
		Event evnt @=> bar_event;
		Event evnt2 @=> beat_event;
		4 => beats_per_bar;
		2 => bars_per_loop;
		setTempo( 120 );
	}
	fun static void run()
	{
		// reset initial values
		-1 => total_bar_count;
		-1 => bar_count;
		-1 => beat_count;
		<<< "Conductor - running loop!",
        "                                                    ." >>>;
		while( true )
		{
			1 +=> beat_count;
			// if we are at the start of a bar!
		    if ((beat_count % beats_per_bar) == 0)
			{
				// increase total bar count
				1 +=> total_bar_count;
				// set loop bar count
				(total_bar_count % bars_per_loop) => bar_count;
				// if we're at the end of a loop, then reset
				// beat count				
				if (beat_count % beats_per_loop == 0)
				{
					0 => beat_count;	
				}
				bar_event.broadcast();
			}
			//<<< "beat ", beat_count, " of bar ", bar_count,
			//"                                                    .">>>;
			beat_event.broadcast();
			beat_length => now;
		}
	}
    fun static void debug( string msg ){
        <<< msg,
        "                                                    ." >>>;
    }
}
//Event evnt @=> Conductor.bar_event;
//Event evnt @=> Conductor.beat_event;
//MetronomeEvent evnt @=> Conductor.evnt;
//Conductor.evnt.setTempo(120);
<<< "Conductor - imported!",
"                                                    ." >>>;
Conductor.init();